<?php
	// --------------------------------------------
	// Completed Download Logfile Parser
	// Matt Collinge, Copyright 2006 
	//    www.mattcollinge.co.uk
	// --------------------------------------------
	// Takes a logfile and reformats it so that 
	// the call log is available as an RSS feed. 
	// --------------------------------------------

	// ----------------------
	// User-defined variables
	// ----------------------
	
	$DOWNLOAD_LOGFILE = 'c:/completed-downloads-log.txt';	// Where's the log file is located
	$NUMBER_OF_FILES = 5;				// How many items go into the RSS feed
	$FEED_TITLE = 'Completed D/L';
	$FEED_DESCRIPTION = 'Completed Downloads';

	// You shouldn't need to modify anything under here.. unless you're messing! ;)
	// ----------------------------------------------------------------------------

	include_once("_feedcreator.class.php");
	$lines = file($DOWNLOAD_LOGFILE);	// Read in the logfile
	$fileLog[] = array();			// Create an array for the call data we'll scrape out
	
	// Quickly parse the file's contents & assign the call data into our array
	// -----------------------------------------------------------------------
	
	for($i=0; $i<count($lines)-1; $i++) {
		$pos = strpos($lines[$i], "** FILE FINISHED");
		if ($pos===false) {
		} else {
			$name = $lines[$i+1];
			$dateTime = $lines[$i+2];
			
			$name = substr($name, 12);
			$pos = strrpos($name, '\\');
			$name = substr($name, $pos+1);
			$dateTime = substr($dateTime, 12);
			
			$fileLog[] = $name .''. $dateTime;
		}
	}
	
	// Now we have the call data, stick it into an RSS feed
	// ----------------------------------------------------

	$rss = new UniversalFeedCreator();
	$rss->useCached();
	$rss->title = $FEED_TITLE;
	$rss->description = $FEED_DESCRIPTION;
	
	for($i=count($fileLog)-1; $i>count($fileLog)-$NUMBER_OF_FILES-1 && $i>0; $i--) {
	    $fileData = split('', $fileLog[$i]);
				
	    $item = new FeedItem();

    	$item->title = $fileData[0];
	    $item->guid = $fileData[0];
	    $item->id = $fileData[0];
    	$item->description 	= '<b><u>Download completed...</u></b><br><b>Name:</b> '.$fileData[0].'<br><b>Date:</b> '.$fileData[1];
	    $item->date = strftime('%Y-%m-%dT%H:%M:%S+01:00', strtotime($fileData[1]));
	    
	    $rss->addItem($item);
	}

	// Feed me!
	// --------
	print $rss->createFeed('RSS2.0');
?>